function AFMMgpu0plots(errorplot)
% AFMMGPU0PLOTS Plots for the paper "Adaptive fast multipole method on
% the GPU".

%Find ndirect plot
plotparams={'LineWidth',0.75};
load examples/data/AFMMgpu0
line1='-k';
line2='--k';
line3='-b';
line4='--b';
if nargin<1
  errorplot=false;
end
%calculate averages for each number of points
% cuda_ndirect=cuda_ndirect(:,:,:,:,10);
% cpu_ndirect=cpu_ndirect(:,:,:,:,10);
% cuda_ndirect2=mean(cuda_ndirect,4);
% cpu_ndirect2=mean(cpu_ndirect,4);
% cuda_ndirect3=mean(cuda_ndirect2,3);
% cpu_ndirect3=mean(cpu_ndirect2,3);
[cpu_ndirect3 cpu_ndirect3stdev]=AFMMgpu_post_process(cpu_ndirect(:,:,:,:,10),2,0);
[cuda_ndirect3 cuda_ndirect3stdev]=AFMMgpu_post_process(cuda_ndirect(:,:,:,:,10),2,0);
cuda_ndirect_total=sum(cuda_ndirect3,2);
cpu_ndirect_total=sum(cpu_ndirect3,2);
cuda_ndirect_total_stdev=sqrt(sum(cuda_ndirect3stdev.^2,2));
cpu_ndirect_total_stdev=sqrt(sum(cpu_ndirect3stdev.^2,2));
cuda_ndirect_scaled=sum(cuda_ndirect3./(ones(size(cuda_ndirect3,1),1)*min(cuda_ndirect3,[],1)),2);
cpu_ndirect_scaled=sum(cpu_ndirect3./(ones(size(cuda_ndirect3,1),1)*min(cpu_ndirect3,[],1)),2);
cuda_ndirect_weigted=sum(cuda_ndirect3./(ones(size(cuda_ndirect3,1),1)*(min(cuda_ndirect3,[],1).*log2(nn))),2);
cpu_ndirect_weigted=sum(cpu_ndirect3./(ones(size(cuda_ndirect3,1),1)*(min(cpu_ndirect3,[],1).*log2(nn))),2);

% production quality figure:
figure(1),
plot(ndir,cuda_ndirect_total/min(cuda_ndirect_total),line1, ...
     ndir,cpu_ndirect_total/min(cpu_ndirect_total),line4,plotparams{:});
if errorplot
  hold on;
  nw = 20; % number of errorbars
  w = floor(numel(ndir)/nw);
  eline1 = [line1(end) '.']; % plot only bars and no graphs
  eline4 = [line4(end) '.'];

  h1 = errorbar(ndir(1:w:end), ...
                cuda_ndirect_total(1:w:end)/min(cuda_ndirect_total), ...
                0.5*cuda_ndirect_total_stdev(1:w:end)/ ...
                min(cuda_ndirect_total), ...
                eline1,plotparams{:});
  h2 = errorbar(ndir(1:w:end), ...
                cpu_ndirect_total(1:w:end)/min(cpu_ndirect_total), ...
                0.5*cpu_ndirect_total_stdev(1:w:end)/ ...
                min(cpu_ndirect_total), ...
                eline4,plotparams{:});

  errorbar_tick(h1,3,'units');
  errorbar_tick(h2,3,'units');
end
%h = title('Ndirect optimum');
h = xlabel('N_{d}'); set(h,'FontSize',10);
h = ylabel('Time'); set(h,'FontSize',10);
h = legend('GPU','CPU'); set(h,'FontSize',10);
set(gca,'xtick',0:10:80,'ytick',[1:0.5:2.5]);
set(gcf,'PaperPositionMode','auto');
% the size used here should be final (no width/height in
% \includegraphics as this will make the fonts look ugly):
set(gcf,'Position',[100 100 400 250]);

figure(2),
plot(ndir,cuda_ndirect_scaled/min(cuda_ndirect_scaled),line1, ...
     ndir,cpu_ndirect_scaled/min(cpu_ndirect_scaled),line4,plotparams{:});
%title('Ndirect optimum');
h = xlabel('N_{d}'); set(h,'FontSize',10);
h = ylabel('Time'); set(h,'FontSize',10);
h = legend('GPU','CPU'); set(h,'FontSize',10);
axis([0 75 1 2])
set(gca,'xtick',0:10:70,'ytick',[1:0.5:2.5]);
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 200]);
print -depsc examples/fig/ndirect.eps
